Subject: bug#62646: closed (Re: Fix for librsvg 2.40 on core-updates)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 08 Apr 2023 09:53:02 +0000

Your bug report

#62646: [PATCH core-updates] gnu: librsvg-2.40: Fix test failure with Pango 1.50.

which was filed against the guix-patches package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
62646: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=62646
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: Fix for librsvg 2.40 on core-updates
From: Andreas Enge <[email-masked]>
To: Kaelyn <[email-masked]>
Cc: guix-devel <[email-masked]>, [email-masked]
Date: Sat, 8 Apr 2023 11:52:29 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello,

Am Fri, Apr 07, 2023 at 04:53:15PM +0000 schrieb Kaelyn:
> On core-updates, librsvg-2.40 fails to compile due to a single failing test (I've confirmed the failure on x86_64 and i686, though the package is only used/needed on non-x86_64 systems for gtk+ and others; it also affects wine and wine-staging on x86_64 as they are 32-bit packages). I was able to track down the test failure to a text rendering difference between Pango 1.48 and 1.50, which led to the text being one pixel line higher between the reference and output images. On Monday I submitted https://issues.guix.gnu.org/62646 which adds a phase to librsvg-2.40 to adjust the output Y coordinate of the SVG transformation matrix by one for the failing test so that it passes with Pango 1.50.

thanks a lot, I added a copyright line for you and pushed.

Wine still fails to build due to autogen not building on i686:
libtool: compile:  gcc -DHAVE_CONFIG_H -I. -I.. -I.. -I../autoopts -DPKGDATADIR=\"/gnu/store/6i60j0fxdsg4qwymas4ymfqlv1azidnc-autogen-5.18.16/share/autogen\" -g -O2 -Wno-format-contains-nul -fno-strict-aliasing -Wall -Werror -Wcast-align -Wmissing-prototypes -Wpointer-arith -Wshadow -Wstrict-prototypes -Wwrite-strings -Wstrict-aliasing=3 -Wextra -Wno-cast-qual -g -O2 -Wno-format-contains-nul -fno-strict-aliasing -c libopts.c  -fPIC -DPIC -o .libs/libopts_la-libopts.o
In file included from libopts.c:48:
usage.c: In function ‘prt_extd_usage.isra’:
usage.c:736:38: error: ‘s ’ directive output may be truncated writing 2 bytes into a region of size between 0 and 9 [-Werror=format-truncation=]
  736 |         snprintf(vfmt, sizeof(vfmt), vfmtfmt, (unsigned int)nmlen + 4);
      |                                      ^~~~~~~
usage.c:736:9: note: ‘snprintf’ output between 9 and 18 bytes into a destination of size 12
  736 |         snprintf(vfmt, sizeof(vfmt), vfmtfmt, (unsigned int)nmlen + 4);
      |         ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Just in case you wish to continue investigating :)

Andreas

Subject: [PATCH core-updates] gnu: librsvg-2.40: Fix test failure with Pango 1.50.
From: Kaelyn Takata <[email-masked]>
To: [email-masked]
Cc: Kaelyn Takata <[email-masked]>
Date: Mon, 03 Apr 2023 16:37:58 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

* gnu/packages/gnome.scm (librsvg-2.40): Fix test failure with Pango 1.50.
---
 gnu/packages/gnome.scm | 6 ++++++
 1 file changed, 6 insertions(+)

diff --git a/gnu/packages/gnome.scm b/gnu/packages/gnome.scm
index e81882b181..fe5860e93f 100644
--- a/gnu/packages/gnome.scm
+++ b/gnu/packages/gnome.scm
@@ -3725,6 +3725,12 @@ (define-public librsvg-2.40
                (("gdk_pixbuf_cache_file = .*$")
                 "gdk_pixbuf_cache_file = $(TMPDIR)/loaders.cache\n"))
              #t))
+         (add-before 'check 'fix-test-with-pango-1.50
+           (lambda _
+	     ;; Changes between pango 1.48 and 1.50 caused the text to be one
+	     ;; pixel lower in the output image compared to the reference.
+             (substitute* "tests/fixtures/reftests/bugs/587721-text-transform.svg"
+	       (("660\\.9") "659.9"))))
          (add-before 'check 'remove-failing-tests
            (lambda _
              (with-directory-excursion "tests/fixtures/reftests"

base-commit: cebcf3533ab83233121434254a6ae7b8c35cfa1f
--
2.39.2